//+------------------------------------------------------------------+
//|                                                    MA ribbon.mq4 |
//|                                               mladenfx@gmail.com |
//|                                                                  |
//| original idea by Jose Silva                                      |
//| Ma Channel Modifield by Steven                                   |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 DarkBlue
#property indicator_color2 FireBrick
#property indicator_color3 DarkBlue
#property indicator_color4 FireBrick
#property indicator_color5 DarkBlue
#property indicator_color6 FireBrick
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 4
#property indicator_width4 4
#property indicator_width5 2
#property indicator_width6 2
//
//
//
//
//

extern int    MaFastPeriod    = 5;
extern int    MaFastMethod    = MODE_EMA;
extern int    MaFastPrice     = PRICE_CLOSE;
extern int    MaMediumPeriod  = 50;
extern int    MaMediumMethod  = MODE_EMA;
extern int    MaMediumPrice   = PRICE_MEDIAN;
extern int    MaHighPeriod    = 50;
extern int    MaHighMethod    = MODE_EMA;
extern int    MaHighPrice     = PRICE_HIGH;
extern int    MaLowPeriod     = 50;
extern int    MaLowMethod     = MODE_EMA;
extern int    MaLowPrice      = PRICE_LOW;
extern bool   AlertOn         = false,
     AlertOnClosedCandle      = true;
extern bool   ShowArrows      = true;
extern int    ArrowWidth      = 1;
extern color  ArrowsUpColor   = Green,
              ArrowsDnColor   = Red;
extern bool   DisplaySignal   = true;                 
extern int    Corner          = 3;               

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
int Trend=0,SignalCandle=0;
datetime LastAlert=0;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   SetIndexBuffer(0,buffer5);
   SetIndexBuffer(1,buffer6);
   SetIndexBuffer(2,buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,buffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,buffer1);
   SetIndexBuffer(5,buffer2);
   if (AlertOnClosedCandle) SignalCandle=1;
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int deinit() { 

   Comment("");
   if (ShowArrows) {
      for (int i=ObjectsTotal()-1;i>=0;i--) {
         if (StringFind(ObjectName(i),"MARibbon")>-1) ObjectDelete(ObjectName(i));
         }
      }
   ObjectDelete("Trade");
   return(0);
} 

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;

   //

   for(i=limit; i>=0; i--)
   {
      buffer1[i] = iMA(NULL,0,MaFastPeriod,0,MaFastMethod,MaFastPrice,i);
      buffer2[i] = iMA(NULL,0,MaMediumPeriod,0,MaMediumMethod,MaMediumPrice,i);
      buffer5[i] = iMA(NULL,0,MaHighPeriod,0,MaHighMethod,MaHighPrice,i);
      buffer6[i] = iMA(NULL,0,MaLowPeriod,0,MaLowMethod,MaLowPrice,i);      
      buffer3[i] = buffer1[i];
      buffer4[i] = buffer2[i];
      if (buffer1[i+SignalCandle]>buffer5[i+SignalCandle] && buffer1[i+1+SignalCandle]<=buffer5[i+1+SignalCandle] && Trend<1) {
         Trend=1;
	      if (ShowArrows) DrawArrow(i+SignalCandle,buffer5[i+SignalCandle],ArrowsUpColor,233,false);
	      }
      else if (buffer1[i+SignalCandle]<buffer6[i+SignalCandle] && buffer1[i+1+SignalCandle]>=buffer6[i+1+SignalCandle] && Trend>-1) {
      	Trend=-1;
      	if (ShowArrows) DrawArrow(i+SignalCandle,buffer6[i+SignalCandle],ArrowsDnColor,234,true);
         }
   }
   if (buffer1[SignalCandle]>buffer5[SignalCandle] && buffer1[SignalCandle+1]<=buffer5[SignalCandle+1] && LastAlert!=Time[0]) {
      LastAlert=Time[0];
      if (AlertOn) Alert("MA Ribbon Buy Alert! - "+Symbol()+"["+Period()+"m]");
      }
   else if (buffer1[SignalCandle]<buffer6[SignalCandle] && buffer1[SignalCandle+1]>=buffer6[SignalCandle+1] && LastAlert!=Time[0]) {
      LastAlert=Time[0];
      if (AlertOn) Alert("MA Ribbon Sell Alert! - "+Symbol()+"["+Period()+"m]");
      }
   string OPstr;
   color OPclr;
   if (Trend>0) {
      OPstr = "BUY";
      OPclr = Green;
      }
   else if (Trend<0) {
      OPstr = "SELL";
      OPclr = Red;
      }
   else {
      OPstr = "NO Trade";
      OPclr = Red;
      }
  
   ObjectCreate("Trade", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Trade", OPstr, 15, "Arial Bold", OPclr);
   ObjectSet("Trade", OBJPROP_CORNER, Corner);
   ObjectSet("Trade", OBJPROP_XDISTANCE, 20);
   ObjectSet("Trade", OBJPROP_YDISTANCE, 20);   
   return(0);
}
void DrawArrow(int i, double ma, color theColor,int theCode,bool up) {
   string name = "MARibbon:"+Time[i];
   double gap  = 3.0*iATR(NULL,0,10,i)/4.0;   
   ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
      ObjectSet(name,OBJPROP_ARROWCODE,theCode);
      ObjectSet(name,OBJPROP_COLOR,theColor);
      ObjectSet(name,OBJPROP_WIDTH,ArrowWidth);
      if (up)
            ObjectSet(name,OBJPROP_PRICE1,ma+gap);
      else  ObjectSet(name,OBJPROP_PRICE1,ma-gap);
   return;
}

